#ifndef CACHE_H
#define CACHE_H

#include "disksim_global.h"
#include "nasd.h"

typedef struct _recordlist{
  Request record;
  struct _recordlist *next;
} Trace_list;
 

typedef struct _cache{
  int diskno;
  int clientno;
  FILE *fd;
  struct disksim *_disksim;
  int completed;
  int free_size;
  int app_number;
  float last_prefetched;
  float negative_error;
  float positive_error;
  Trace_list *list;
} Cache;

int init_client_cache(Cache *cache, int clientno, int size, FILE *fd, struct disksim *_disksim);
int close_client_cache(Cache *cache);
int init_disk_cache(Cache *cache, int diskno, int size, FILE *fd, struct disksim *_disksim);
int close_disk_cache(Cache *cache);
int add_record(Cache *cache, Request record);
int delete_record(Cache *cache, Request record);
int cache_lookup(Cache *cache, Request io_request);
int update_cache(Cache *cache, Request io_request);
/* do no harm rule */
int aggressive(Cache *cache, Request *record); 
int fixed_horizen(Cache *cache, Request *record, int total_hit);
int fixed_fetch(Cache *cache, Request *record);
int no_prefetch(Cache *cache, Request *record);
#endif
