#include <stdio.h>
#include <stdlib.h>
#include "nasd.h"

static int cache[10];
static int cache_number = 0;
static int free_memory[10];
static FILE *fd;

typedef struct _record{
  double time;
  int size;
  int client;
} Trace_record;

typedef struct _recordHash{
  Trace_record record;
  struct _recordHash *next;
} Trace_hash;
 
int hash(Trace_record _record);
int add_record(Trace_record _record);
int delete_record(Trace_record record);
Trace_hash * hash_table[100];


int hash(Trace_record record){
  int i;

  i = (int)record.time;
  return i%100;
}

int add_record(Trace_record record){
  int i;
  Trace_hash *temp, *temp_next;

  i = hash(record);
  temp = temp_next = hash_table[i];
  if(!temp){
    hash_table[i] = malloc(sizeof(Trace_hash));
    hash_table[i]->record.time = record.time;
    hash_table[i]->record.size = record.size;
    hash_table[i]->record.client = record.client;
    hash_table[i]->next = NULL;
  }
  else{
    while(temp_next){
      temp_next = temp->next;
      temp = temp_next;
    }
    temp->next = malloc(sizeof(Trace_hash)); 
    temp_next = temp->next;
    temp_next->record.time = record.time;
    temp_next->record.size = record.size;
    temp_next->record.client = record.client;
    temp_next->next = NULL;
  }
  free_memory[record.client] = free_memory[record.client] - record.size;
  return 0;
}

int delete_record(Trace_record record){
  int i;
  Trace_hash *temp, *temp_next;
  
  i = hash(record);
  temp = temp_next = hash_table[i];

  while(abs(temp_next->record.time - record.time) > 0.0001){
    temp_next = temp->next;
    temp = temp_next;
  }
  if(temp_next == NULL){
    return -1;
  }
  else if(temp_next == hash_table[i]){
    free(hash_table[i]);
    hash_table[i] = NULL;
  }
  else{
    temp->next = temp_next->next;
    free(temp_next);
  }

  free_memory[record.client] += record.size;
  return 0;
}

int init_client(int client_no, int cache_size, char *tracefile){
  int i;

  
  cache_number = clinet_no;
  for(i = 0; i< client_no; i++){
    cache[i] = cache_size;
    free_memory = (int)(cache_size/512);
  }
 
  fd = fopen(tracefile, "r");
  free_memory = (int)(cache_size/512);
  for(i= 0; i<100; i++){
    hash_table[i] = NULL;
  }
  return 0;
}

int close_client(){
  int i;
  Trace_hash *temp, *temp_next;

  for(i =0; i<100; i++){
    temp = hash_table[i];
    if(temp){
      temp_next = temp->next;
      free(temp);
      temp = temp->next;
    }
  }

  fclose(fd);
  return 0;
}

int caching_prefetching(double time){
  return 0;
}

int cache_lookup(Request *io_request){
  Trace_record record;
  Trace_hash *temp;
  int i;

  record.time = io_request->start;
  record.size = io_request->bcount;

  i = hash(record);
  temp = temp = hash_table[i];
  while(temp){
    if(abs(temp->record.time - record.time) < 0.0001){
      return 1;
    }
    else temp = temp->next;
  }
  return 0;
}


